./goblint --conf conf/svcomp23.json --sets ana.specification /mnt/goblint-svcomp/benchexec/sv-benchmarks/c/properties/unreach-call.prp --sets exp.architecture 32bit /mnt/goblint-svcomp/benchexec/sv-benchmarks/c/ntdrivers/diskperf.i.cil-2.c


--------------------------------------------------------------------------------


--sets is deprecated, use --set instead.
--sets is deprecated, use --set instead.
unrolling loop at lib/libc/stub/src/stdlib.c:10:5-12:5 with factor 12
unrolling loop at lib/libc/stub/src/stdlib.c:21:9-27:9 with factor 4
unrolling loop at lib/libc/stub/src/stdlib.c:40:3-45:3 with factor 6
unrolling loop at /mnt/goblint-svcomp/benchexec/sv-benchmarks/c/ntdrivers/diskperf.i.cil-2.c:2625:7-2637:7 with factor 8
unrolling loop at /mnt/goblint-svcomp/benchexec/sv-benchmarks/c/ntdrivers/diskperf.i.cil-2.c:3049:9-3061:9 with factor 8
Collected factors:
functions: 126
functionCalls: 220
loops: 8
loopBreaks: 0
controlFlowStatements: 574
expressions: 6782
instructions: 765
integralVars: (23,211)
arrayVars: (3,0)
pointerVars: (2,250)

Complexity estimates:
File: 12296
no thread creation -> disabeling thread analyses "race, deadlock, maylocks, symb_locks, thread, threadid, threadJoins, threadreturn"
Total: 41646
Congruence: 15842
Enabled congruence domain.
SV-COMP specification: CHECK( init(main()), LTL(G ! call(reach_error())) )
[Info][Unsound] Unknown address in {&irp} has escaped. (/mnt/goblint-svcomp/benchexec/sv-benchmarks/c/ntdrivers/diskperf.i.cil-2.c:3231:3-3231:15)
[Info][Unsound] Unknown value in {&irp} could be an escaped pointer address! (/mnt/goblint-svcomp/benchexec/sv-benchmarks/c/ntdrivers/diskperf.i.cil-2.c:3231:3-3231:15)
[Info][Unsound] Unknown value in {?} could be an escaped pointer address! (/mnt/goblint-svcomp/benchexec/sv-benchmarks/c/ntdrivers/diskperf.i.cil-2.c:3231:3-3231:15)
[Info][Unsound] Unknown address in {&irp} has escaped. (/mnt/goblint-svcomp/benchexec/sv-benchmarks/c/ntdrivers/diskperf.i.cil-2.c:3278:17-3278:56)
[Info][Unsound] Unknown value in {&irp} could be an escaped pointer address! (/mnt/goblint-svcomp/benchexec/sv-benchmarks/c/ntdrivers/diskperf.i.cil-2.c:3278:17-3278:56)
[Info][Unsound] Unknown address in {&devobj} has escaped. (/mnt/goblint-svcomp/benchexec/sv-benchmarks/c/ntdrivers/diskperf.i.cil-2.c:3278:17-3278:56)
[Info][Unsound] Unknown value in {&devobj} could be an escaped pointer address! (/mnt/goblint-svcomp/benchexec/sv-benchmarks/c/ntdrivers/diskperf.i.cil-2.c:3278:17-3278:56)
[Info][Unsound] Unknown value in {?} could be an escaped pointer address! (/mnt/goblint-svcomp/benchexec/sv-benchmarks/c/ntdrivers/diskperf.i.cil-2.c:3278:17-3278:56)
[Info][Unsound] Unknown address in {&irp} has escaped. (/mnt/goblint-svcomp/benchexec/sv-benchmarks/c/ntdrivers/diskperf.i.cil-2.c:2424:3-2424:29)
[Info][Unsound] Unknown value in {&irp} could be an escaped pointer address! (/mnt/goblint-svcomp/benchexec/sv-benchmarks/c/ntdrivers/diskperf.i.cil-2.c:2424:3-2424:29)
[Info][Unsound] Unknown value in {?} could be an escaped pointer address! (/mnt/goblint-svcomp/benchexec/sv-benchmarks/c/ntdrivers/diskperf.i.cil-2.c:2424:3-2424:29)
[Info][Unsound] Unknown address in {&irp} has escaped. (/mnt/goblint-svcomp/benchexec/sv-benchmarks/c/ntdrivers/diskperf.i.cil-2.c:3283:17-3283:63)
[Info][Unsound] Unknown value in {&irp} could be an escaped pointer address! (/mnt/goblint-svcomp/benchexec/sv-benchmarks/c/ntdrivers/diskperf.i.cil-2.c:3283:17-3283:63)
[Info][Unsound] Unknown address in {&devobj} has escaped. (/mnt/goblint-svcomp/benchexec/sv-benchmarks/c/ntdrivers/diskperf.i.cil-2.c:3283:17-3283:63)
[Info][Unsound] Unknown value in {&devobj} could be an escaped pointer address! (/mnt/goblint-svcomp/benchexec/sv-benchmarks/c/ntdrivers/diskperf.i.cil-2.c:3283:17-3283:63)
[Info][Unsound] Unknown value in {?} could be an escaped pointer address! (/mnt/goblint-svcomp/benchexec/sv-benchmarks/c/ntdrivers/diskperf.i.cil-2.c:3283:17-3283:63)
[Warning][Integer > Overflow][CWE-190] Unsigned integer overflow (/mnt/goblint-svcomp/benchexec/sv-benchmarks/c/ntdrivers/diskperf.i.cil-2.c:2607:11-2607:68)
[Info][Unsound] Unknown address in {&irp} has escaped. (/mnt/goblint-svcomp/benchexec/sv-benchmarks/c/ntdrivers/diskperf.i.cil-2.c:2611:9-2611:35)
[Info][Unsound] Unknown value in {&irp} could be an escaped pointer address! (/mnt/goblint-svcomp/benchexec/sv-benchmarks/c/ntdrivers/diskperf.i.cil-2.c:2611:9-2611:35)
[Info][Unsound] Unknown value in {?} could be an escaped pointer address! (/mnt/goblint-svcomp/benchexec/sv-benchmarks/c/ntdrivers/diskperf.i.cil-2.c:2611:9-2611:35)
[Info][Unsound] Unknown value in {&frequency___0} could be an escaped pointer address! (/mnt/goblint-svcomp/benchexec/sv-benchmarks/c/ntdrivers/diskperf.i.cil-2.c:2620:7-2620:55)
[Info][Unsound] Unknown value in {&((alloc@sid:1216@tid:Top Threads(#top)), /mnt/goblint-svcomp/benchexec/sv-benchmarks/c/ntdrivers/diskperf.i.cil-2.c:3231:3-3231:15)} could be an escaped pointer address! (/mnt/goblint-svcomp/benchexec/sv-benchmarks/c/ntdrivers/diskperf.i.cil-2.c:2633:9-2633:68)
[Warning][Integer > Overflow][CWE-190][CWE-191] Signed integer overflow and underflow (/mnt/goblint-svcomp/benchexec/sv-benchmarks/c/ntdrivers/diskperf.i.cil-2.c:3159:3-3159:71)
[Warning][Integer > Overflow][CWE-190][CWE-191] Signed integer overflow and underflow (/mnt/goblint-svcomp/benchexec/sv-benchmarks/c/ntdrivers/diskperf.i.cil-2.c:3160:3-3160:77)
[Warning][Integer > Overflow][CWE-191] Unsigned integer underflow (/mnt/goblint-svcomp/benchexec/sv-benchmarks/c/ntdrivers/diskperf.i.cil-2.c:2640:7-2640:62)
[Warning][Integer > Overflow][CWE-190][CWE-191] Signed integer overflow and underflow (/mnt/goblint-svcomp/benchexec/sv-benchmarks/c/ntdrivers/diskperf.i.cil-2.c:2642:9-2642:89)
[Warning][Integer > Overflow][CWE-190] Signed integer overflow (/mnt/goblint-svcomp/benchexec/sv-benchmarks/c/ntdrivers/diskperf.i.cil-2.c:2644:11-2644:102)
[Warning][Integer > Overflow][CWE-190][CWE-191] Signed integer overflow and underflow (/mnt/goblint-svcomp/benchexec/sv-benchmarks/c/ntdrivers/diskperf.i.cil-2.c:2644:11-2644:102)
[Info][Unsound] Unknown address in {&irp} has escaped. (/mnt/goblint-svcomp/benchexec/sv-benchmarks/c/ntdrivers/diskperf.i.cil-2.c:2662:5-2662:31)
[Info][Unsound] Unknown value in {&irp} could be an escaped pointer address! (/mnt/goblint-svcomp/benchexec/sv-benchmarks/c/ntdrivers/diskperf.i.cil-2.c:2662:5-2662:31)
[Info][Unsound] Unknown value in {&((alloc@sid:1216@tid:Top Threads(#top)), /mnt/goblint-svcomp/benchexec/sv-benchmarks/c/ntdrivers/diskperf.i.cil-2.c:3231:3-3231:15)} could be an escaped pointer address! (/mnt/goblint-svcomp/benchexec/sv-benchmarks/c/ntdrivers/diskperf.i.cil-2.c:2662:5-2662:31)
[Info][Unsound] Unknown value in {?} could be an escaped pointer address! (/mnt/goblint-svcomp/benchexec/sv-benchmarks/c/ntdrivers/diskperf.i.cil-2.c:2662:5-2662:31)
[Warning][Integer > Overflow][CWE-190] Signed integer overflow (/mnt/goblint-svcomp/benchexec/sv-benchmarks/c/ntdrivers/diskperf.i.cil-2.c:2667:5-2667:67)
[Info][Unsound] Unknown address given as function argument (/mnt/goblint-svcomp/benchexec/sv-benchmarks/c/ntdrivers/diskperf.i.cil-2.c:2669:5-2669:66)
[Info][Unsound] Unknown address in {&irp} has escaped. (/mnt/goblint-svcomp/benchexec/sv-benchmarks/c/ntdrivers/diskperf.i.cil-2.c:2669:5-2669:66)
[Info][Unsound] Unknown value in {&irp} could be an escaped pointer address! (/mnt/goblint-svcomp/benchexec/sv-benchmarks/c/ntdrivers/diskperf.i.cil-2.c:2669:5-2669:66)
[Info][Unsound] Unknown value in {?} could be an escaped pointer address! (/mnt/goblint-svcomp/benchexec/sv-benchmarks/c/ntdrivers/diskperf.i.cil-2.c:2669:5-2669:66)
[Info][Unsound] Unknown address in {&irp} has escaped. (/mnt/goblint-svcomp/benchexec/sv-benchmarks/c/ntdrivers/diskperf.i.cil-2.c:3288:17-3288:61)
[Info][Unsound] Unknown value in {&irp} could be an escaped pointer address! (/mnt/goblint-svcomp/benchexec/sv-benchmarks/c/ntdrivers/diskperf.i.cil-2.c:3288:17-3288:61)
[Info][Unsound] Unknown address in {&devobj} has escaped. (/mnt/goblint-svcomp/benchexec/sv-benchmarks/c/ntdrivers/diskperf.i.cil-2.c:3288:17-3288:61)
[Info][Unsound] Unknown value in {&devobj} could be an escaped pointer address! (/mnt/goblint-svcomp/benchexec/sv-benchmarks/c/ntdrivers/diskperf.i.cil-2.c:3288:17-3288:61)
[Info][Unsound] Unknown value in {?} could be an escaped pointer address! (/mnt/goblint-svcomp/benchexec/sv-benchmarks/c/ntdrivers/diskperf.i.cil-2.c:3288:17-3288:61)
[Info][Unsound] Unknown address in {&irp} has escaped. (/mnt/goblint-svcomp/benchexec/sv-benchmarks/c/ntdrivers/diskperf.i.cil-2.c:2257:9-2257:58)
[Info][Unsound] Unknown value in {&irp} could be an escaped pointer address! (/mnt/goblint-svcomp/benchexec/sv-benchmarks/c/ntdrivers/diskperf.i.cil-2.c:2257:9-2257:58)
[Info][Unsound] Unknown address in {&devobj} has escaped. (/mnt/goblint-svcomp/benchexec/sv-benchmarks/c/ntdrivers/diskperf.i.cil-2.c:2257:9-2257:58)
[Info][Unsound] Unknown value in {&devobj} could be an escaped pointer address! (/mnt/goblint-svcomp/benchexec/sv-benchmarks/c/ntdrivers/diskperf.i.cil-2.c:2257:9-2257:58)
[Info][Unsound] Unknown value in {?} could be an escaped pointer address! (/mnt/goblint-svcomp/benchexec/sv-benchmarks/c/ntdrivers/diskperf.i.cil-2.c:2257:9-2257:58)
[Warning][Integer > Overflow][CWE-190] Signed integer overflow (/mnt/goblint-svcomp/benchexec/sv-benchmarks/c/ntdrivers/diskperf.i.cil-2.c:2332:3-2332:65)
[Info][Unsound] Unknown address given as function argument (/mnt/goblint-svcomp/benchexec/sv-benchmarks/c/ntdrivers/diskperf.i.cil-2.c:2335:3-2335:64)
[Info][Unsound] Unknown address in {&irp} has escaped. (/mnt/goblint-svcomp/benchexec/sv-benchmarks/c/ntdrivers/diskperf.i.cil-2.c:2335:3-2335:64)
[Info][Unsound] Unknown value in {&irp} could be an escaped pointer address! (/mnt/goblint-svcomp/benchexec/sv-benchmarks/c/ntdrivers/diskperf.i.cil-2.c:2335:3-2335:64)
[Info][Unsound] Unknown value in {?} could be an escaped pointer address! (/mnt/goblint-svcomp/benchexec/sv-benchmarks/c/ntdrivers/diskperf.i.cil-2.c:2335:3-2335:64)
[Info][Unsound] Unknown address in {&irp} has escaped. (/mnt/goblint-svcomp/benchexec/sv-benchmarks/c/ntdrivers/diskperf.i.cil-2.c:2247:9-2247:56)
[Info][Unsound] Unknown value in {&irp} could be an escaped pointer address! (/mnt/goblint-svcomp/benchexec/sv-benchmarks/c/ntdrivers/diskperf.i.cil-2.c:2247:9-2247:56)
[Info][Unsound] Unknown address in {&devobj} has escaped. (/mnt/goblint-svcomp/benchexec/sv-benchmarks/c/ntdrivers/diskperf.i.cil-2.c:2247:9-2247:56)
[Info][Unsound] Unknown value in {&devobj} could be an escaped pointer address! (/mnt/goblint-svcomp/benchexec/sv-benchmarks/c/ntdrivers/diskperf.i.cil-2.c:2247:9-2247:56)
[Info][Unsound] Unknown value in {?} could be an escaped pointer address! (/mnt/goblint-svcomp/benchexec/sv-benchmarks/c/ntdrivers/diskperf.i.cil-2.c:2247:9-2247:56)
[Info][Unsound] Unknown address in {&irp} has escaped. (/mnt/goblint-svcomp/benchexec/sv-benchmarks/c/ntdrivers/diskperf.i.cil-2.c:2287:3-2287:60)
[Info][Unsound] Unknown value in {&irp} could be an escaped pointer address! (/mnt/goblint-svcomp/benchexec/sv-benchmarks/c/ntdrivers/diskperf.i.cil-2.c:2287:3-2287:60)
[Info][Unsound] Unknown address in {&devobj} has escaped. (/mnt/goblint-svcomp/benchexec/sv-benchmarks/c/ntdrivers/diskperf.i.cil-2.c:2287:3-2287:60)
[Info][Unsound] Unknown value in {&devobj} could be an escaped pointer address! (/mnt/goblint-svcomp/benchexec/sv-benchmarks/c/ntdrivers/diskperf.i.cil-2.c:2287:3-2287:60)
[Info][Unsound] Unknown value in {?} could be an escaped pointer address! (/mnt/goblint-svcomp/benchexec/sv-benchmarks/c/ntdrivers/diskperf.i.cil-2.c:2287:3-2287:60)
[Info][Imprecise] Invalidating expressions: CastE(TPtr(TVoid( const  ),
                                ), Lval(Var(irpSp, NoOffset))), CastE(TNamed(size_t___0, TInt(unsigned int, ), ), CastE(TInt(long, ), AddrOf(Mem(CastE(TPtr(TNamed(IO_STACK_LOCATION, TComp(struct _IO_STACK_LOCATION, MajorFunction : TNamed(UCHAR, TInt(unsigned char, ), ), MinorFunction : TNamed(UCHAR, TInt(unsigned char, ), ), Flags : TNamed(UCHAR, TInt(unsigned char, ), ), Control : TNamed(UCHAR, TInt(unsigned char, ), ), Parameters : TComp(union __anonunion_Parameters_55, Create : TComp(struct __anonstruct_Create_56, SecurityContext : TNamed(PIO_SECURITY_CONTEXT, TPtr(TComp(struct _IO_SECURITY_CONTEXT, SecurityQos : TNamed(PSECURITY_QUALITY_OF_SERVICE, TPtr(TComp(struct _SECURITY_QUALITY_OF_SERVICE, Length : TNamed(ULONG, TInt(unsigned long, ), ), ImpersonationLevel : TNamed(SECURITY_IMPERSONATION_LEVEL, Enum(_SECURITY_IMPERSONATION_LEVEL,), ), ContextTrackingMode : TNamed(SECURITY_CONTEXT_TRACKING_MODE, TNamed(BOOLEAN, TNamed(UCHAR, TInt(unsigned char, ), ), ), ), EffectiveOnly : TNamed(BOOLEAN, TNamed(UCHAR, TInt(unsigned char, ), ), ), , ), ), ), AccessState : TNamed(PACCESS_STATE, TPtr(TComp(struct _ACCESS_STATE, OperationID : TNamed(LUID, TComp(struct _LUID, LowPart : TNamed(ULONG, TInt(unsigned long, ), ), HighPart : TNamed(LONG, TInt(long, ), ), , ), ), SecurityEvaluated : TNamed(BOOLEAN, TNamed(UCHAR, TInt(unsigned char, ), ), ), GenerateAudit : TNamed(BOOLEAN, TNamed(UCHAR, TInt(unsigned char, ), ), ), GenerateOnClose : TNamed(BOOLEAN, TNamed(UCHAR, TInt(unsigned char, ), ), ), PrivilegesAllocated : TNamed(BOOLEAN, TNamed(UCHAR, TInt(unsigned char, ), ), ), Flags : TNamed(ULONG, TInt(unsigned long, ), ), RemainingDesiredAccess : TNamed(ACCESS_MASK, TNamed(ULONG, TInt(unsigned long, ), ), ), PreviouslyGrantedAccess : TNamed(ACCESS_MASK, TNamed(ULONG, TInt(unsigned long, ), ), ), OriginalDesiredAccess : TNamed(ACCESS_MASK, TNamed(ULONG, TInt(unsigned long, ), ), ), SubjectSecurityContext : TNamed(SECURITY_SUBJECT_CONTEXT, TComp(struct _SECURITY_SUBJECT_CONTEXT, ClientToken : TNamed(PACCESS_TOKEN, TNamed(PVOID, TPtr(TVoid(), ), ), ), ImpersonationLevel : TNamed(SECURITY_IMPERSONATION_LEVEL, Enum(_SECURITY_IMPERSONATION_LEVEL,), ), PrimaryToken : TNamed(PACCESS_TOKEN, TNamed(PVOID, TPtr(TVoid(), ), ), ), ProcessAuditId : TNamed(PVOID, TPtr(TVoid(), ), ), , ), ), SecurityDescriptor : TNamed(PSECURITY_DESCRIPTOR, TNamed(PVOID, TPtr(TVoid(), ), ), ), AuxData : TNamed(PVOID, TPtr(TVoid(), ), ), Privileges : TComp(union __anonunion_Privileges_40, InitialPrivilegeSet : TNamed(INITIAL_PRIVILEGE_SET, TComp(struct _INITIAL_PRIVILEGE_SET, PrivilegeCount : TNamed(ULONG, TInt(unsigned long, ), ), Control : TNamed(ULONG, TInt(unsigned long, ), ), Privilege : TArray(TNamed(LUID_AND_ATTRIBUTES, TComp(struct _LUID_AND_ATTRIBUTES, Luid : TNamed(LUID, TCompLoop(struct _LUID, _, ), ), Attributes : TNamed(ULONG, TInt(unsigned long, ), ), , ), ), Some(Const(Int(3,int,3))), ), , ), ), PrivilegeSet : TNamed(PRIVILEGE_SET, TComp(struct _PRIVILEGE_SET, PrivilegeCount : TNamed(ULONG, TInt(unsigned long, ), ), Control : TNamed(ULONG, TInt(unsigned long, ), ), Privilege : TArray(TNamed(LUID_AND_ATTRIBUTES, TCompLoop(struct _LUID_AND_ATTRIBUTES, _, ), ), Some(Const(Int(1,int,1))), ), , ), ), , ), AuditPrivileges : TNamed(BOOLEAN, TNamed(UCHAR, TInt(unsigned char, ), ), ), ObjectName : TNamed(UNICODE_STRING, TComp(struct _UNICODE_STRING, Length : TNamed(USHORT, TInt(unsigned short, ), ), MaximumLength : TNamed(USHORT, TInt(unsigned short, ), ), Buffer : TNamed(PWSTR, TPtr(TNamed(WCHAR, TNamed(wchar_t___0, TInt(unsigned short, ), ), ), ), ), , ), ), ObjectTypeName : TNamed(UNICODE_STRING, TCompLoop(struct _UNICODE_STRING, _, ), ), , ), ), ), DesiredAccess : TNamed(ACCESS_MASK, TNamed(ULONG, TInt(unsigned long, ), ), ), FullCreateOptions : TNamed(ULONG, TInt(unsigned long, ), ), , ), ), ), Options : TNamed(ULONG, TInt(unsigned long, ), ), FileAttributes : TNamed(USHORT, TInt(unsigned short, ), ), ShareAccess : TNamed(USHORT, TInt(unsigned short, ), ), EaLength : TNamed(ULONG, TInt(unsigned long, ), ), , ), Read : TComp(struct __anonstruct_Read_57, Length : TNamed(ULONG, TInt(unsigned long, ), ), Key : TNamed(ULONG, TInt(unsigned long, ), ), ByteOffset : TNamed(LARGE_INTEGER, TCompLoop(union _LARGE_INTEGER, _, ), ), , ), Write : TComp(struct __anonstruct_Write_58, Length : TNamed(ULONG, TInt(unsigned long, ), ), Key : TNamed(ULONG, TInt(unsigned long, ), ), ByteOffset : TNamed(LARGE_INTEGER, TCompLoop(union _LARGE_INTEGER, _, ), ), , ), QueryFile : TComp(struct __anonstruct_QueryFile_59, Length : TNamed(ULONG, TInt(unsigned long, ), ), FileInformationClass : TNamed(FILE_INFORMATION_CLASS, Enum(_FILE_INFORMATION_CLASS,), ), , ), SetFile : TComp(struct __anonstruct_SetFile_60, Length : TNamed(ULONG, TInt(unsigned long, ), ), FileInformationClass : TNamed(FILE_INFORMATION_CLASS, Enum(_FILE_INFORMATION_CLASS,), ), FileObject : TNamed(PFILE_OBJECT, TPtr(TComp(struct _FILE_OBJECT, Type : TNamed(CSHORT, TInt(short, ), ), Size : TNamed(CSHORT, TInt(short, ), ), DeviceObject : TNamed(PDEVICE_OBJECT, TPtr(TComp(struct _DEVICE_OBJECT, Type : TNamed(CSHORT, TInt(short, ), ), Size : TNamed(USHORT, TInt(unsigned short, ), ), ReferenceCount : TNamed(LONG, TInt(long, ), ), DriverObject : TPtr(TComp(struct _DRIVER_OBJECT, Type : TNamed(CSHORT, TInt(short, ), ), Size : TNamed(CSHORT, TInt(short, ), ), DeviceObject : TNamed(PDEVICE_OBJECT, TPtr(TCompLoop(struct _DEVICE_OBJECT, _, ), ), ), Flags : TNamed(ULONG, TInt(unsigned long, ), ), DriverStart : TNamed(PVOID, TPtr(TVoid(), ), ), DriverSize : TNamed(ULONG, TInt(unsigned long, ), ), DriverSection : TNamed(PVOID, TPtr(TVoid(), ), ), DriverExtension : TNamed(PDRIVER_EXTENSION, TPtr(TComp(struct _DRIVER_EXTENSION, DriverObject : TPtr(TCompLoop(struct _DRIVER_OBJECT, _, ), ), AddDevice : TPtr(TFun(TNamed(NTSTATUS, TNamed(LONG, TInt(long, ), ), ), DriverObject: TPtr(TCompLoop(struct _DRIVER_OBJECT, _, ), ), PhysicalDeviceObject: TPtr(TCompLoop(struct _DEVICE_OBJECT, _, ), ), ), ), Count : TNamed(ULONG, TInt(unsigned long, ), ), ServiceKeyName : TNamed(UNICODE_STRING, TCompLoop(struct _UNICODE_STRING, _, ), ), , ), ), ), DriverName : TNamed(UNICODE_STRING, TCompLoop(struct _UNICODE_STRING, _, ), ), HardwareDatabase : TNamed(PUNICODE_STRING, TPtr(TNamed(UNICODE_STRING, TCompLoop(struct _UNICODE_STRING, _, ), ), ), ), FastIoDispatch : TNamed(PFAST_IO_DISPATCH, TPtr(TComp(struct _FAST_IO_DISPATCH, SizeOfFastIoDispatch : TNamed(ULONG, TInt(unsigned long, ), ), FastIoCheckIfPossible : TPtr(TFun(TNamed(BOOLEAN, TNamed(UCHAR, TInt(unsigned char, ), ), ), FileObject: TPtr(TCompLoop(struct _FILE_OBJECT, _, ), ), FileOffset: TNamed(PLARGE_INTEGER, TPtr(TNamed(LARGE_INTEGER, TCompLoop(union _LARGE_INTEGER, _, ), ), ), ), Length: TNamed(ULONG, TInt(unsigned long, ), ), Wait: TNamed(BOOLEAN, TNamed(UCHAR, TInt(unsigned char, ), ), ), LockKey: TNamed(ULONG, TInt(unsigned long, ), ), CheckForReadOperation: TNamed(BOOLEAN, TNamed(UCHAR, TInt(unsigned char, ), ), ), IoStatus: TNamed(PIO_STATUS_BLOCK, TPtr(TComp(struct _IO_STATUS_BLOCK, __annonCompField4 : TComp(union __anonunion____missing_field_name_6, Status : TNamed(NTSTATUS, TNamed(LONG, TInt(long, ), ), ), Pointer : TNamed(PVOID, TPtr(TVoid(), ), ), , ), Information : TNamed(ULONG_PTR, TInt(unsigned long, ), ), , ), ), ), DeviceObject: TPtr(TCompLoop(struct _DEVICE_OBJECT, _, ), ), ), ), FastIoRead : TPtr(TFun(TNamed(BOOLEAN, TNamed(UCHAR, TInt(unsigned char, ), ), ), FileObject: TPtr(TCompLoop(struct _FILE_OBJECT, _, ), ), FileOffset: TNamed(PLARGE_INTEGER, TPtr(TNamed(LARGE_INTEGER, TCompLoop(union _LARGE_INTEGER, _, ), ), ), ), Length: TNamed(ULONG, TInt(unsigned long, ), ), Wait: TNamed(BOOLEAN, TNamed(UCHAR, TInt(unsigned char, ), ), ), LockKey: TNamed(ULONG, TInt(unsigned long, ), ), Buffer: TNamed(PVOID, TPtr(TVoid(), ), ), IoStatus: TNamed(PIO_STATUS_BLOCK, TPtr(TCompLoop(struct _IO_STATUS_BLOCK, _, ), ), ), DeviceObject: TPtr(TCompLoop(struct _DEVICE_OBJECT, _, ), ), ), ), FastIoWrite : TPtr(TFun(TNamed(BOOLEAN, TNamed(UCHAR, TInt(unsigned char, ), ), ), FileObject: TPtr(TCompLoop(struct _FILE_OBJECT, _, ), ), FileOffset: TNamed(PLARGE_INTEGER, TPtr(TNamed(LARGE_INTEGER, TCompLoop(union _LARGE_INTEGER, _, ), ), ), ), Length: TNamed(ULONG, TInt(unsigned long, ), ), Wait: TNamed(BOOLEAN, TNamed(UCHAR, TInt(unsigned char, ), ), ), LockKey: TNamed(ULONG, TInt(unsigned long, ), ), Buffer: TNamed(PVOID, TPtr(TVoid(), ), ), IoStatus: TNamed(PIO_STATUS_BLOCK, TPtr(TCompLoop(struct _IO_STATUS_BLOCK, _, ), ), ), DeviceObject: TPtr(TCompLoop(struct _DEVICE_OBJECT, _, ), ), ), ), FastIoQueryBasicInfo : TPtr(TFun(TNamed(BOOLEAN, TNamed(UCHAR, TInt(unsigned char, ), ), ), FileObject: TPtr(TCompLoop(struct _FILE_OBJECT, _, ), ), Wait: TNamed(BOOLEAN, TNamed(UCHAR, TInt(unsigned char, ), ), ), Buffer: TNamed(PFILE_BASIC_INFORMATION, TPtr(TComp(struct _FILE_BASIC_INFORMATION, CreationTime : TNamed(LARGE_INTEGER, TCompLoop(union _LARGE_INTEGER, _, ), ), LastAccessTime : TNamed(LARGE_INTEGER, TCompLoop(union _LARGE_INTEGER, _, ), ), LastWriteTime : TNamed(LARGE_INTEGER, TCompLoop(union _LARGE_INTEGER, _, ), ), ChangeTime : TNamed(LARGE_INTEGER, TCompLoop(union _LARGE_INTEGER, _, ), ), FileAttributes : TNamed(ULONG, TInt(unsigned long, ), ), , ), ), ), IoStatus: TNamed(PIO_STATUS_BLOCK, TPtr(TCompLoop(struct _IO_STATUS_BLOCK, _, ), ), ), DeviceObject: TPtr(TCompLoop(struct _DEVICE_OBJECT, _, ), ), ), ), FastIoQueryStandardInfo : TPtr(TFun(TNamed(BOOLEAN, TNamed(UCHAR, TInt(unsigned char, ), ), ), FileObject: TPtr(TCompLoop(struct _FILE_OBJECT, _, ), ), Wait: TNamed(BOOLEAN, TNamed(UCHAR, TInt(unsigned char, ), ), ), Buffer: TNamed(PFILE_STANDARD_INFORMATION, TPtr(TComp(struct _FILE_STANDARD_INFORMATION, AllocationSize : TNamed(LARGE_INTEGER, TCompLoop(union _LARGE_INTEGER, _, ), ), EndOfFile : TNamed(LARGE_INTEGER, TCompLoop(union _LARGE_INTEGER, _, ), ), NumberOfLinks : TNamed(ULONG, TInt(unsigned long, ), ), DeletePending : TNamed(BOOLEAN, TNamed(UCHAR, TInt(unsigned char, ), ), ), Directory : TNamed(BOOLEAN, TNamed(UCHAR, TInt(unsigned char, ), ), ), , ), ), ), IoStatus: TNamed(PIO_STATUS_BLOCK, TPtr(TCompLoop(struct _IO_STATUS_BLOCK, _, ), ), ), DeviceObject: TPtr(TCompLoop(struct _DEVICE_OBJECT, _, ), ), ), ), FastIoLock : TPtr(TFun(TNamed(BOOLEAN, TNamed(UCHAR, TInt(unsigned char, ), ), ), FileObject: TPtr(TCompLoop(struct _FILE_OBJECT, _, ), ), FileOffset: TNamed(PLARGE_INTEGER, TPtr(TNamed(LARGE_INTEGER, TCompLoop(union _LARGE_INTEGER, _, ), ), ), ), Length: TNamed(PLARGE_INTEGER, TPtr(TNamed(LARGE_INTEGER, TCompLoop(union _LARGE_INTEGER, _, ), ), ), ), ProcessId: TNamed(PEPROCESS, TPtr(TComp(struct _EPROCESS, , , ), ), ), Key: TNamed(ULONG, TInt(unsigned long, ), ), FailImmediately: TNamed(BOOLEAN, TNamed(UCHAR, TInt(unsigned char, ), ), ), ExclusiveLock: TNamed(BOOLEAN, TNamed(UCHAR, TInt(unsigned char, ), ), ), IoStatus: TNamed(PIO_STATUS_BLOCK, TPtr(TCompLoop(struct _IO_STATUS_BLOCK, _, ), ), ), DeviceObject: TPtr(TCompLoop(struct _DEVICE_OBJECT, _, ), ), ), ), FastIoUnlockSingle : TPtr(TFun(TNamed(BOOLEAN, TNamed(UCHAR, TInt(unsigned char, ), ), ), FileObject: TPtr(TCompLoop(struct _FILE_OBJECT, _, ), ), FileOffset: TNamed(PLARGE_INTEGER, TPtr(TNamed(LARGE_INTEGER, TCompLoop(union _LARGE_INTEGER, _, ), ), ), ), Length: TNamed(PLARGE_INTEGER, TPtr(TNamed(LARGE_INTEGER, TCompLoop(union _LARGE_INTEGER, _, ), ), ), ), ProcessId: TNamed(PEPROCESS, TPtr(TCompLoop(struct _EPROCESS, _, ), ), ), Key: TNamed(ULONG, TInt(unsigned long, ), ), IoStatus: TNamed(PIO_STATUS_BLOCK, TPtr(TCompLoop(struct _IO_STATUS_BLOCK, _, ), ), ), DeviceObject: TPtr(TCompLoop(struct _DEVICE_OBJECT, _, ), ), ), ), FastIoUnlockAll : TPtr(TFun(TNamed(BOOLEAN, TNamed(UCHAR, TInt(unsigned char, ), ), ), FileObject: TPtr(TCompLoop(struct _FILE_OBJECT, _, ), ), ProcessId: TNamed(PEPROCESS, TPtr(TCompLoop(struct _EPROCESS, _, ), ), ), IoStatus: TNamed(PIO_STATUS_BLOCK, TPtr(TCompLoop(struct _IO_STATUS_BLOCK, _, ), ), ), DeviceObject: TPtr(TCompLoop(struct _DEVICE_OBJECT, _, ), ), ), ), FastIoUnlockAllByKey : TPtr(TFun(TNamed(BOOLEAN, TNamed(UCHAR, TInt(unsigned char, ), ), ), FileObject: TPtr(TCompLoop(struct _FILE_OBJECT, _, ), ), ProcessId: TNamed(PVOID, TPtr(TVoid(), ), ), Key: TNamed(ULONG, TInt(unsigned long, ), ), IoStatus: TNamed(PIO_STATUS_BLOCK, TPtr(TCompLoop(struct _IO_STATUS_BLOCK, _, ), ), ), DeviceObject: TPtr(TCompLoop(struct _DEVICE_OBJECT, _, ), ), ), ), FastIoDeviceControl : TPtr(TFun(TNamed(BOOLEAN, TNamed(UCHAR, TInt(unsigned char, ), ), ), FileObject: TPtr(TCompLoop(struct _FILE_OBJECT, _, ), ), Wait: TNamed(BOOLEAN, TNamed(UCHAR, TInt(unsigned char, ), ), ), InputBuffer: TNamed(PVOID, TPtr(TVoid(), ), ), InputBufferLength: TNamed(ULONG, TInt(unsigned long, ), ), OutputBuffer: TNamed(PVOID, TPtr(TVoid(), ), ), OutputBufferLength: TNamed(ULONG, TInt(unsigned long, ), ), IoControlCode: TNamed(ULONG, TInt(unsigned long, ), ), IoStatus: TNamed(PIO_STATUS_BLOCK, TPtr(TCompLoop(struct _IO_STATUS_BLOCK, _, ), ), ), DeviceObject: TPtr(TCompLoop(struct _DEVICE_OBJECT, _, ), ), ), ), AcquireFileForNtCreateSection : TPtr(TFun(TVoid(), FileObject: TPtr(TCompLoop(struct _FILE_OBJECT, _, ), ), ), ), ReleaseFileForNtCreateSection : TPtr(TFun(TVoid(), FileObject: TPtr(TCompLoop(struct _FILE_OBJECT, _, ), ), ), ), FastIoDetachDevice : TPtr(TFun(TVoid(), SourceDevice: TPtr(TCompLoop(struct _DEVICE_OBJECT, _, ), ), TargetDevice: TPtr(TCompLoop(struct _DEVICE_OBJECT, _, ), ), ), ), FastIoQueryNetworkOpenInfo : TPtr(TFun(TNamed(BOOLEAN, TNamed(UCHAR, TInt(unsigned char, ), ), ), FileObject: TPtr(TCompLoop(struct _FILE_OBJECT, _, ), ), Wait: TNamed(BOOLEAN, TNamed(UCHAR, TInt(unsigned char, ), ), ), Buffer: TPtr(TComp(struct _FILE_NETWORK_OPEN_INFORMATION, CreationTime : TNamed(LARGE_INTEGER, TCompLoop(union _LARGE_INTEGER, _, ), ), LastAccessTime : TNamed(LARGE_INTEGER, TCompLoop(union _LARGE_INTEGER, _, ), ), LastWriteTime : TNamed(LARGE_INTEGER, TCompLoop(union _LARGE_INTEGER, _, ), ), ChangeTime : TNamed(LARGE_INTEGER, TCompLoop(union _LARGE_INTEGER, _, ), ), AllocationSize : TNamed(LARGE_INTEGER, TCompLoop(union _LARGE_INTEGER, _, ), ), EndOfFile : TNamed(LARGE_INTEGER, TCompLoop(union _LARGE_INTEGER, _, ), ), FileAttributes : TNamed(ULONG, TInt(unsigned long, ), ), , ), ), IoStatus: TPtr(TCompLoop(struct _IO_STATUS_BLOCK, _, ), ), DeviceObject: TPtr(TCompLoop(struct _DEVICE_OBJECT, _, ), ), ), ), AcquireForModWrite : TPtr(TFun(TNamed(NTSTATUS, TNamed(LONG, TInt(long, ), ), ), FileObject: TPtr(TCompLoop(struct _FILE_OBJECT, _, ), ), EndingOffset: TNamed(PLARGE_INTEGER, TPtr(TNamed(LARGE_INTEGER, TCompLoop(union _LARGE_INTEGER, _, ), ), ), ), ResourceToRelease: TPtr(TPtr(TComp(struct _ERESOURCE, SystemResourcesList : TNamed(LIST_ENTRY, TComp(struct _LIST_ENTRY, Flink : TPtr(TCompLoop(struct _LIST_ENTRY, _, ), ), Blink : TPtr(TCompLoop(struct _LIST_ENTRY, _, ), ), , ), ), OwnerTable : TNamed(POWNER_ENTRY, TPtr(TComp(struct _OWNER_ENTRY, OwnerThread : TNamed(ERESOURCE_THREAD, TNamed(ULONG_PTR, TInt(unsigned long, ), ), ), __annonCompField10 : TComp(union __anonunion____missing_field_name_38, OwnerCount : TNamed(LONG, TInt(long, ), ), TableSize : TNamed(ULONG, TInt(unsigned long, ), ), , ), , ), ), ), ActiveCount : TNamed(SHORT, TInt(short, ), ), Flag : TNamed(USHORT, TInt(unsigned short, ), ), SharedWaiters : TNamed(PKSEMAPHORE, TPtr(TComp(struct _KSEMAPHORE, Header : TNamed(DISPATCHER_HEADER, TComp(struct _DISPATCHER_HEADER, Type : TNamed(UCHAR, TInt(unsigned char, ), ), Absolute : TNamed(UCHAR, TInt(unsigned char, ), ), Size : TNamed(UCHAR, TInt(unsigned char, ), ), Inserted : TNamed(UCHAR, TInt(unsigned char, ), ), SignalState : TNamed(LONG, TInt(long, ), ), WaitListHead : TNamed(LIST_ENTRY, TCompLoop(struct _LIST_ENTRY, _, ), ), , ), ), Limit : TNamed(LONG, TInt(long, ), ), , ), ), ), ExclusiveWaiters : TNamed(PKEVENT, TPtr(TComp(struct _KEVENT, Header : TNamed(DISPATCHER_HEADER, TCompLoop(struct _DISPATCHER_HEADER, _, ), ), , ), ), ), OwnerThreads : TArray(TNamed(OWNER_ENTRY, TCompLoop(struct _OWNER_ENTRY, _, ), ), Some(Const(Int(2,int,2))), ), ContentionCount : TNamed(ULONG, TInt(unsigned long, ), ), NumberOfSharedWaiters : TNamed(USHORT, TInt(unsigned short, ), ), NumberOfExclusiveWaiters : TNamed(USHORT, TInt(unsigned short, ), ), __annonCompField11 : TComp(union __anonunion____missing_field_name_39, Address : TNamed(PVOID, TPtr(TVoid(), ), ), CreatorBackTraceIndex : TNamed(ULONG_PTR, TInt(unsigned long, ), ), , ), SpinLock : TNamed(KSPIN_LOCK, TNamed(ULONG_PTR, TInt(unsigned long, ), ), ), , ), ), ), DeviceObject: TPtr(TCompLoop(struct _DEVICE_OBJECT, _, ), ), ), ), MdlRead : TPtr(TFun(TNamed(BOOLEAN, TNamed(UCHAR, TInt(unsigned char, ), ), ), FileObject: TPtr(TCompLoop(struct _FILE_OBJECT, _, ), ), FileOffset: TNamed(PLARGE_INTEGER, TPtr(TNamed(LARGE_INTEGER, TCompLoop(union _LARGE_INTEGER, _, ), ), ), ), Length: TNamed(ULONG, TInt(unsigned long, ), ), LockKey: TNamed(ULONG, TInt(unsigned long, ), ), MdlChain: TPtr(TNamed(PMDL, TPtr(TComp(struct _MDL, Next : TPtr(TCompLoop(struct _MDL, _, ), ), Size : TNamed(CSHORT, TInt(short, ), ), MdlFlags : TNamed(CSHORT, TInt(short, ), ), Process : TPtr(TCompLoop(struct _EPROCESS, _, ), ), MappedSystemVa : TNamed(PVOID, TPtr(TVoid(), ), ), StartVa : TNamed(PVOID, TPtr(TVoid(), ), ), ByteCount : TNamed(ULONG, TInt(unsigned long, ), ), ByteOffset : TNamed(ULONG, TInt(unsigned long, ), ), , ), ), ), ), IoStatus: TNamed(PIO_STATUS_BLOCK, TPtr(TCompLoop(struct _IO_STATUS_BLOCK, _, ), ), ), DeviceObject: TPtr(TCompLoop(struct _DEVICE_OBJECT, _, ), ), ), ), MdlReadComplete : TPtr(TFun(TNamed(BOOLEAN, TNamed(UCHAR, TInt(unsigned char, ), ), ), FileObject: TPtr(TCompLoop(struct _FILE_OBJECT, _, ), ), MdlChain: TNamed(PMDL, TPtr(TCompLoop(struct _MDL, _, ), ), ), DeviceObject: TPtr(TCompLoop(struct _DEVICE_OBJECT, _, ), ), ), ), PrepareMdlWrite : TPtr(TFun(TNamed(BOOLEAN, TNamed(UCHAR, TInt(unsigned char, ), ), ), FileObject: TPtr(TCompLoop(struct _FILE_OBJECT, _, ), ), FileOffset: TNamed(PLARGE_INTEGER, TPtr(TNamed(LARGE_INTEGER, TCompLoop(union _LARGE_INTEGER, _, ), ), ), ), Length: TNamed(ULONG, TInt(unsigned long, ), ), LockKey: TNamed(ULONG, TInt(unsigned long, ), ), MdlChain: TPtr(TNamed(PMDL, TPtr(TCompLoop(struct _MDL, _, ), ), ), ), IoStatus: TNamed(PIO_STATUS_BLOCK, TPtr(TCompLoop(struct _IO_STATUS_BLOCK, _, ), ), ), DeviceObject: TPtr(TCompLoop(struct _DEVICE_OBJECT, _, ), ), ), ), MdlWriteComplete : TPtr(TFun(TNamed(BOOLEAN, TNamed(UCHAR, TInt(unsigned char, ), ), ), FileObject: TPtr(TCompLoop(struct _FILE_OBJECT, _, ), ), FileOffset: TNamed(PLARGE_INTEGER, TPtr(TNamed(LARGE_INTEGER, TCompLoop(union _LARGE_INTEGER, _, ), ), ), ), MdlChain: TNamed(PMDL, TPtr(TCompLoop(struct _MDL, _, ), ), ), DeviceObject: TPtr(TCompLoop(struct _DEVICE_OBJECT, _, ), ), ), ), FastIoReadCompressed : TPtr(TFun(TNamed(BOOLEAN, TNamed(UCHAR, TInt(unsigned char, ), ), ), FileObject: TPtr(TCompLoop(struct _FILE_OBJECT, _, ), ), FileOffset: TNamed(PLARGE_INTEGER, TPtr(TNamed(LARGE_INTEGER, TCompLoop(union _LARGE_INTEGER, _, ), ), ), ), Length: TNamed(ULONG, TInt(unsigned long, ), ), LockKey: TNamed(ULONG, TInt(unsigned long, ), ), Buffer: TNamed(PVOID, TPtr(TVoid(), ), ), MdlChain: TPtr(TNamed(PMDL, TPtr(TCompLoop(struct _MDL, _, ), ), ), ), IoStatus: TNamed(PIO_STATUS_BLOCK, TPtr(TCompLoop(struct _IO_STATUS_BLOCK, _, ), ), ), CompressedDataInfo: TPtr(TComp(struct _COMPRESSED_DATA_INFO, , , ), ), CompressedDataInfoLength: TNamed(ULONG, TInt(unsigned long, ), ), DeviceObject: TPtr(TCompLoop(struct _DEVICE_OBJECT, _, ), ), ), ), FastIoWriteCompressed : TPtr(TFun(TNamed(BOOLEAN, TNamed(UCHAR, TInt(unsigned char, ), ), ), FileObject: TPtr(TCompLoop(struct _FILE_OBJECT, _, ), ), FileOffset: TNamed(PLARGE_INTEGER, TPtr(TNamed(LARGE_INTEGER, TCompLoop(union _LARGE_INTEGER, _, ), ), ), ), Length: TNamed(ULONG, TInt(unsigned long, ), ), LockKey: TNamed(ULONG, TInt(unsigned long, ), ), Buffer: TNamed(PVOID, TPtr(TVoid(), ), ), MdlChain: TPtr(TNamed(PMDL, TPtr(TCompLoop(struct _MDL, _, ), ), ), ), IoStatus: TNamed(PIO_STATUS_BLOCK, TPtr(TCompLoop(struct _IO_STATUS_BLOCK, _, ), ), ), CompressedDataInfo: TPtr(TCompLoop(struct _COMPRESSED_DATA_INFO, _, ), ), CompressedDataInfoLength: TNamed(ULONG, TInt(unsigned long, ), ), DeviceObject: TPtr(TCompLoop(struct _DEVICE_OBJECT, _, ), ), ), ), MdlReadCompleteCompressed : TPtr(TFun(TNamed(BOOLEAN, TNamed(UCHAR, TInt(unsigned char, ), ), ), FileObject: TPtr(TCompLoop(struct _FILE_OBJECT, _, ), ), MdlChain: TNamed(PMDL, TPtr(TCompLoop(struct _MDL, _, ), ), ), DeviceObject: TPtr(TCompLoop(struct _DEVICE_OBJECT, _, ), ), ), ), MdlWriteCompleteCompressed : TPtr(TFun(TNamed(BOOLEAN, TNamed(UCHAR, TInt(unsigned char, ), ), ), FileObject: TPtr(TCompLoop(struct _FILE_OBJECT, _, ), ), FileOffset: TNamed(PLARGE_INTEGER, TPtr(TNamed(LARGE_INTEGER, TCompLoop(union _LARGE_INTEGER, _, ), ), ), ), MdlChain: TNamed(PMDL, TPtr(TCompLoop(struct _MDL, _, ), ), ), DeviceObject: TPtr(TCompLoop(struct _DEVICE_OBJECT, _, ), ), ), ), FastIoQueryOpen : TPtr(TFun(TNamed(BOOLEAN, TNamed(UCHAR, TInt(unsigned char, ), ), ), Irp: TPtr(TComp(struct _IRP, Type : TNamed(CSHORT, TInt(short, ), ), Size : TNamed(USHORT, TInt(unsigned short, ), ), MdlAddress : TNamed(PMDL, TPtr(TCompLoop(struct _MDL, _, ), ), ), Flags : TNamed(ULONG, TInt(unsigned long, ), ), AssociatedIrp : TComp(union __anonunion_AssociatedIrp_44, MasterIrp : TPtr(TCompLoop(struct _IRP, _, ), ), IrpCount : TNamed(LONG, TInt(long, ), ), SystemBuffer : TNamed(PVOID, TPtr(TVoid(), ), ), , ), ThreadListEntry : TNamed(LIST_ENTRY, TCompLoop(struct _LIST_ENTRY, _, ), ), IoStatus : TNamed(IO_STATUS_BLOCK, TCompLoop(struct _IO_STATUS_BLOCK, _, ), ), RequestorMode : TNamed(KPROCESSOR_MODE, TNamed(CCHAR, TInt(char, ), ), ), PendingReturned : TNamed(BOOLEAN, TNamed(UCHAR, TInt(unsigned char, ), ), ), StackCount : TNamed(CHAR, TInt(char, ), ), CurrentLocation : TNamed(CHAR, TInt(char, ), ), Cancel : TNamed(BOOLEAN, TNamed(UCHAR, TInt(unsigned char, ), ), ), CancelIrql : TNamed(KIRQL, TNamed(UCHAR, TInt(unsigned char, ), ), ), ApcEnvironment : TNamed(CCHAR, TInt(char, ), ), AllocationFlags : TNamed(UCHAR, TInt(unsigned char, ), ), UserIosb : TNamed(PIO_STATUS_BLOCK, TPtr(TCompLoop(struct _IO_STATUS_BLOCK, _, ), ), ), UserEvent : TNamed(PKEVENT, TPtr(TCompLoop(struct _KEVENT, _, ), ), ), Overlay : TComp(union __anonunion_Overlay_45, AsynchronousParameters : TComp(struct __anonstruct_AsynchronousParameters_46, UserApcRoutine : TPtr(TFun(TVoid(), ApcContext: TNamed(PVOID, TPtr(TVoid(), ), ), IoStatusBlock: TNamed(PIO_STATUS_BLOCK, TPtr(TCompLoop(struct _IO_STATUS_BLOCK, _, ), ), ), Reserved: TNamed(ULONG, TInt(unsigned long, ), ), ), ), UserApcContext : TNamed(PVOID, TPtr(TVoid(), ), ), , ), AllocationSize : TNamed(LARGE_INTEGER, TCompLoop(union _LARGE_INTEGER, _, ), ), , ), CancelRoutine : TPtr(TFun(TVoid(), DeviceObject: TPtr(TCompLoop(struct _DEVICE_OBJECT, _, ), ), Irp: TPtr(TCompLoop(struct _IRP, _, ), ), ), ), UserBuffer : TNamed(PVOID, TPtr(TVoid(), ), ), Tail : TComp(union __anonunion_Tail_47, Overlay : TComp(struct __anonstruct_Overlay_48, __annonCompField15 : TComp(union __anonunion____missing_field_name_49, DeviceQueueEntry : TNamed(KDEVICE_QUEUE_ENTRY, TComp(struct _KDEVICE_QUEUE_ENTRY, DeviceListEntry : TNamed(LIST_ENTRY, TCompLoop(struct _LIST_ENTRY, _, ), ), SortKey : TNamed(ULONG, TInt(unsigned long, ), ), Inserted : TNamed(BOOLEAN, TNamed(UCHAR, TInt(unsigned char, ), ), ), , ), ), __annonCompField14 : TComp(struct __anonstruct____missing_field_name_50, DriverContext : TArray(TNamed(PVOID, TPtr(TVoid(), ), ), Some(Const(Int(4,int,4))), ), , ), , ), Thread : TNamed(PETHREAD, TPtr(TComp(struct _ETHREAD, , , ), ), ), AuxiliaryBuffer : TNamed(PCHAR, TPtr(TNamed(CHAR, TInt(char, ), ), ), ), __annonCompField17 : TComp(struct __anonstruct____missing_field_name_51, ListEntry : TNamed(LIST_ENTRY, TCompLoop(struct _LIST_ENTRY, _, ), ), __annonCompField16 : TComp(union __anonunion____missing_field_name_52, CurrentStackLocation : TPtr(TCompLoop(struct _IO_STACK_LOCATION, _, ), ), PacketType : TNamed(ULONG, TInt(unsigned long, ), ), , ), , ), OriginalFileObject : TNamed(PFILE_OBJECT, TPtr(TCompLoop(struct _FILE_OBJECT, _, ), ), ), , ), Apc : TNamed(KAPC, TComp(struct _KAPC, Type : TNamed(CSHORT, TInt(short, ), ), Size : TNamed(CSHORT, TInt(short, ), ), Spare0 : TNamed(ULONG, TInt(unsigned long, ), ), Thread : TPtr(TComp(struct _KTHREAD, , , ), ), ApcListEntry : TNamed(LIST_ENTRY, TCompLoop(struct _LIST_ENTRY, _, ), ), KernelRoutine : TPtr(TFun(TVoid(), Apc: TPtr(TCompLoop(struct _KAPC, _, ), ), NormalRoutine: TPtr(TNamed(PKNORMAL_ROUTINE, TPtr(TFun(TVoid(), NormalContext: TNamed(PVOID, TPtr(TVoid(), ), ), SystemArgument1: TNamed(PVOID, TPtr(TVoid(), ), ), SystemArgument2: TNamed(PVOID, TPtr(TVoid(), ), ), ), ), ), ), NormalContext: TPtr(TNamed(PVOID, TPtr(TVoid(), ), ), ), SystemArgument1: TPtr(TNamed(PVOID, TPtr(TVoid(), ), ), ), SystemArgument2: TPtr(TNamed(PVOID, TPtr(TVoid(), ), ), ), ), ), RundownRoutine : TPtr(TFun(TVoid(), Apc: TPtr(TCompLoop(struct _KAPC, _, ), ), ), ), NormalRoutine : TPtr(TFun(TVoid(), NormalContext: TNamed(PVOID, TPtr(TVoid(), ), ), SystemArgument1: TNamed(PVOID, TPtr(TVoid(), ), ), SystemArgument2: TNamed(PVOID, TPtr(TVoid(), ), ), ), ), NormalContext : TNamed(PVOID, TPtr(TVoid(), ), ), SystemArgument1 : TNamed(PVOID, TPtr(TVoid(), ), ), SystemArgument2 : TNamed(PVOID, TPtr(TVoid(), ), ), ApcStateIndex : TNamed(CCHAR, TInt(char, ), ), ApcMode : TNamed(KPROCESSOR_MODE, TNamed(CCHAR, TInt(char, ), ), ), Inserted : TNamed(BOOLEAN, TNamed(UCHAR, TInt(unsigned char, ), ), ), , ), ), CompletionKey : TNamed(PVOID, TPtr(TVoid(), ), ), , ), , ), ), NetworkInformation: TNamed(PFILE_NETWORK_OPEN_INFORMATION, TPtr(TCompLoop(struct _FILE_NETWORK_OPEN_INFORMATION, _, ), ), ), DeviceObject: TPtr(TCompLoop(struct _DEVICE_OBJECT, _, ), ), ), ), ReleaseForModWrite : TPtr(TFun(TNamed(NTSTATUS, TNamed(LONG, TInt(long, ), ), ), FileObject: TPtr(TCompLoop(struct _FILE_OBJECT, _, ), ), ResourceToRelease: TPtr(TCompLoop(struct _ERESOURCE, _, ), ), DeviceObject: TPtr(TCompLoop(struct _DEVICE_OBJECT, _, ), ), ), ), AcquireForCcFlush : TPtr(TFun(TNamed(NTSTATUS, TNamed(LONG, TInt(long, ), ), ), FileObject: TPtr(TCompLoop(struct _FILE_OBJECT, _, ), ), DeviceObject: TPtr(TCompLoop(struct _DEVICE_OBJECT, _, ), ), ), ), ReleaseForCcFlush : TPtr(TFun(TNamed(NTSTATUS, TNamed(LONG, TInt(long, ), ), ), FileObject: TPtr(TCompLoop(struct _FILE_OBJECT, _, ), ), DeviceObject: TPtr(TCompLoop(struct _DEVICE_OBJECT, _, ), ), ), ), , ), ), ), DriverInit : TPtr(TFun(TNamed(NTSTATUS, TNamed(LONG, TInt(long, ), ), ), DriverObject: TPtr(TCompLoop(struct _DRIVER_OBJECT, _, ), ), RegistryPath: TNamed(PUNICODE_STRING, TPtr(TNamed(UNICODE_STRING, TCompLoop(struct _UNICODE_STRING, _, ), ), ), ), ), ), DriverStartIo : TPtr(TFun(TVoid(), DeviceObject: TPtr(TCompLoop(struct _DEVICE_OBJECT, _, ), ), Irp: TPtr(TCompLoop(struct _IRP, _, ), ), ), ), DriverUnload : TPtr(TFun(TVoid(), DriverObject: TPtr(TCompLoop(struct _DRIVER_OBJECT, _, ), ), ), ), MajorFunction : TArray(TNamed(PDRIVER_DISPATCH, TPtr(TFun(TNamed(NTSTATUS, TNamed(LONG, TInt(long, ), ), ), DeviceObject: TPtr(TCompLoop(struct _DEVICE_OBJECT, _, ), ), Irp: TPtr(TCompLoop(struct _IRP, _, ), ), ), ), ), Some(Const(Int(28,int,28))), ), , ), ), NextDevice : TPtr(TCompLoop(struct _DEVICE_OBJECT, _, ), ), AttachedDevice : TPtr(TCompLoop(struct _DEVICE_OBJECT, _, ), ), CurrentIrp : TPtr(TCompLoop(struct _IRP, _, ), ), Timer : TNamed(PIO_TIMER, TPtr(TComp(struct _IO_TIMER, , , ), ), ), Flags : TNamed(ULONG, TInt(unsigned long, ), ), Characteristics : TNamed(ULONG, TInt(unsigned long, ), ), Vpb : TNamed(PVPB, TPtr(TComp(struct _VPB, Type : TNamed(CSHORT, TInt(short, ), ), Size : TNamed(CSHORT, TInt(short, ), ), Flags : TNamed(USHORT, TInt(unsigned short, ), ), VolumeLabelLength : TNamed(USHORT, TInt(unsigned short, ), ), DeviceObject : TPtr(TCompLoop(struct _DEVICE_OBJECT, _, ), ), RealDevice : TPtr(TCompLoop(struct _DEVICE_OBJECT, _, ), ), SerialNumber : TNamed(ULONG, TInt(unsigned long, ), ), ReferenceCount : TNamed(ULONG, TInt(unsigned long, ), ), VolumeLabel : TArray(TNamed(WCHAR, TNamed(wchar_t___0, TInt(unsigned short, ), ), ), Some(/(*(Const(Int(20,unsigned long,None)), sizeof(TNamed(WCHAR, TNamed(wchar_t___0, TInt(unsigned short, ), ), ))), sizeof(TNamed(WCHAR, TNamed(wchar_t___0, TInt(unsigned short, ), ), )))), ), , ), ), ), DeviceExtension : TNamed(PVOID, TPtr(TVoid(), ), ), DeviceType : TNamed(ULONG, TInt(unsigned long, ), ), StackSize : TNamed(CCHAR, TInt(char, ), ), Queue : TComp(union __anonunion_Queue_43, ListEntry : TNamed(LIST_ENTRY, TCompLoop(struct _LIST_ENTRY, _, ), ), Wcb : TNamed(WAIT_CONTEXT_BLOCK, TComp(struct _WAIT_CONTEXT_BLOCK, WaitQueueEntry : TNamed(KDEVICE_QUEUE_ENTRY, TCompLoop(struct _KDEVICE_QUEUE_ENTRY, _, ), ), DeviceRoutine : TPtr(TFun(TNamed(IO_ALLOCATION_ACTION, Enum(_IO_ALLOCATION_ACTION,), ), DeviceObject: TPtr(TCompLoop(struct _DEVICE_OBJECT, _, ), ), Irp: TPtr(TCompLoop(struct _IRP, _, ), ), MapRegisterBase: TNamed(PVOID, TPtr(TVoid(), ), ), Context: TNamed(PVOID, TPtr(TVoid(), ), ), ), ), DeviceContext : TNamed(PVOID, TPtr(TVoid(), ), ), NumberOfMapRegisters : TNamed(ULONG, TInt(unsigned long, ), ), DeviceObject : TNamed(PVOID, TPtr(TVoid(), ), ), CurrentIrp : TNamed(PVOID, TPtr(TVoid(), ), ), BufferChainingDpc : TNamed(PKDPC, TPtr(TComp(struct _KDPC, Type : TNamed(CSHORT, TInt(short, ), ), Number : TNamed(UCHAR, TInt(unsigned char, ), ), Importance : TNamed(UCHAR, TInt(unsigned char, ), ), DpcListEntry : TNamed(LIST_ENTRY, TCompLoop(struct _LIST_ENTRY, _, ), ), DeferredRoutine : TPtr(TFun(TVoid(), Dpc: TPtr(TCompLoop(struct _KDPC, _, ), ), DeferredContext: TNamed(PVOID, TPtr(TVoid(), ), ), SystemArgument1: TNamed(PVOID, TPtr(TVoid(), ), ), SystemArgument2: TNamed(PVOID, TPtr(TVoid(), ), ), ), ), DeferredContext : TNamed(PVOID, TPtr(TVoid(), ), ), SystemArgument1 : TNamed(PVOID, TPtr(TVoid(), ), ), SystemArgument2 : TNamed(PVOID, TPtr(TVoid(), ), ), Lock : TNamed(PULONG_PTR, TPtr(TInt(unsigned long, ), ), ), , ), ), ), , ), ), , ), AlignmentRequirement : TNamed(ULONG, TInt(unsigned long, ), ), DeviceQueue : TNamed(KDEVICE_QUEUE, TComp(struct _KDEVICE_QUEUE, Type : TNamed(CSHORT, TInt(short, ), ), Size : TNamed(CSHORT, TInt(short, ), ), DeviceListHead : TNamed(LIST_ENTRY, TCompLoop(struct _LIST_ENTRY, _, ), ), Lock : TNamed(KSPIN_LOCK, TNamed(ULONG_PTR, TInt(unsigned long, ), ), ), Busy : TNamed(BOOLEAN, TNamed(UCHAR, TInt(unsigned char, ), ), ), , ), ), Dpc : TNamed(KDPC, TCompLoop(struct _KDPC, _, ), ), ActiveThreadCount : TNamed(ULONG, TInt(unsigned long, ), ), SecurityDescriptor : TNamed(PSECURITY_DESCRIPTOR, TNamed(PVOID, TPtr(TVoid(), ), ), ), DeviceLock : TNamed(KEVENT, TCompLoop(struct _KEVENT, _, ), ), SectorSize : TNamed(USHORT, TInt(unsigned short, ), ), Spare1 : TNamed(USHORT, TInt(unsigned short, ), ), DeviceObjectExtension : TPtr(TComp(struct _DEVOBJ_EXTENSION, Type : TNamed(CSHORT, TInt(short, ), ), Size : TNamed(USHORT, TInt(unsigned short, ), ), DeviceObject : TNamed(PDEVICE_OBJECT, TPtr(TCompLoop(struct _DEVICE_OBJECT, _, ), ), ), , ), ), Reserved : TNamed(PVOID, TPtr(TVoid(), ), ), , ), ), ), Vpb : TNamed(PVPB, TPtr(TCompLoop(struct _VPB, _, ), ), ), FsContext : TNamed(PVOID, TPtr(TVoid(), ), ), FsContext2 : TNamed(PVOID, TPtr(TVoid(), ), ), SectionObjectPointer : TNamed(PSECTION_OBJECT_POINTERS, TPtr(TNamed(SECTION_OBJECT_POINTERS, TComp(struct _SECTION_OBJECT_POINTERS, DataSectionObject : TNamed(PVOID, TPtr(TVoid(), ), ), SharedCacheMap : TNamed(PVOID, TPtr(TVoid(), ), ), ImageSectionObject : TNamed(PVOID, TPtr(TVoid(), ), ), , ), ), ), ), PrivateCacheMap : TNamed(PVOID, TPtr(TVoid(), ), ), FinalStatus : TNamed(NTSTATUS, TNamed(LONG, TInt(long, ), ), ), RelatedFileObject : TPtr(TCompLoop(struct _FILE_OBJECT, _, ), ), LockOperation : TNamed(BOOLEAN, TNamed(UCHAR, TInt(unsigned char, ), ), ), DeletePending : TNamed(BOOLEAN, TNamed(UCHAR, TInt(unsigned char, ), ), ), ReadAccess : TNamed(BOOLEAN, TNamed(UCHAR, TInt(unsigned char, ), ), ), WriteAccess : TNamed(BOOLEAN, TNamed(UCHAR, TInt(unsigned char, ), ), ), DeleteAccess : TNamed(BOOLEAN, TNamed(UCHAR, TInt(unsigned char, ), ), ), SharedRead : TNamed(BOOLEAN, TNamed(UCHAR, TInt(unsigned char, ), ), ), SharedWrite : TNamed(BOOLEAN, TNamed(UCHAR, TInt(unsigned char, ), ), ), SharedDelete : TNamed(BOOLEAN, TNamed(UCHAR, TInt(unsigned char, ), ), ), Flags : TNamed(ULONG, TInt(unsigned long, ), ), FileName : TNamed(UNICODE_STRING, TCompLoop(struct _UNICODE_STRING, _, ), ), CurrentByteOffset : TNamed(LARGE_INTEGER, TCompLoop(union _LARGE_INTEGER, _, ), ), Waiters : TNamed(ULONG, TInt(unsigned long, ), ), Busy : TNamed(ULONG, TInt(unsigned long, ), ), LastLock : TNamed(PVOID, TPtr(TVoid(), ), ), Lock : TNamed(KEVENT, TCompLoop(struct _KEVENT, _, ), ), Event : TNamed(KEVENT, TCompLoop(struct _KEVENT, _, ), ), CompletionContext : TNamed(PIO_COMPLETION_CONTEXT, TPtr(TComp(struct _IO_COMPLETION_CONTEXT, Port : TNamed(PVOID, TPtr(TVoid(), ), ), Key : TNamed(PVOID, TPtr(TVoid(), ), ), , ), ), ), , ), ), ), __annonCompField19 : TComp(union __anonunion____missing_field_name_61, __annonCompField18 : TComp(struct __anonstruct____missing_field_name_62, ReplaceIfExists : TNamed(BOOLEAN, TNamed(UCHAR, TInt(unsigned char, ), ), ), AdvanceOnly : TNamed(BOOLEAN, TNamed(UCHAR, TInt(unsigned char, ), ), ), , ), ClusterCount : TNamed(ULONG, TInt(unsigned long, ), ), DeleteHandle : TNamed(HANDLE, TPtr(TVoid(), ), ), , ), , ), QueryVolume : TComp(struct __anonstruct_QueryVolume_63, Length : TNamed(ULONG, TInt(unsigned long, ), ), FsInformationClass : TNamed(FS_INFORMATION_CLASS, Enum(_FSINFOCLASS,), ), , ), DeviceIoControl : TComp(struct __anonstruct_DeviceIoControl_64, OutputBufferLength : TNamed(ULONG, TInt(unsigned long, ), ), InputBufferLength : TNamed(ULONG, TInt(unsigned long, ), ), IoControlCode : TNamed(ULONG, TInt(unsigned long, ), ), Type3InputBuffer : TNamed(PVOID, TPtr(TVoid(), ), ), , ), QuerySecurity : TComp(struct __anonstruct_QuerySecurity_65, SecurityInformation : TNamed(SECURITY_INFORMATION, TNamed(ULONG, TInt(unsigned long, ), ), ), Length : TNamed(ULONG, TInt(unsigned long, ), ), , ), SetSecurity : TComp(struct __anonstruct_SetSecurity_66, SecurityInformation : TNamed(SECURITY_INFORMATION, TNamed(ULONG, TInt(unsigned long, ), ), ), SecurityDescriptor : TNamed(PSECURITY_DESCRIPTOR, TNamed(PVOID, TPtr(TVoid(), ), ), ), , ), MountVolume : TComp(struct __anonstruct_MountVolume_67, Vpb : TNamed(PVPB, TPtr(TCompLoop(struct _VPB, _, ), ), ), DeviceObject : TNamed(PDEVICE_OBJECT, TPtr(TCompLoop(struct _DEVICE_OBJECT, _, ), ), ), , ), VerifyVolume : TComp(struct __anonstruct_VerifyVolume_68, Vpb : TNamed(PVPB, TPtr(TCompLoop(struct _VPB, _, ), ), ), DeviceObject : TNamed(PDEVICE_OBJECT, TPtr(TCompLoop(struct _DEVICE_OBJECT, _, ), ), ), , ), Scsi : TComp(struct __anonstruct_Scsi_69, Srb : TPtr(TComp(struct _SCSI_REQUEST_BLOCK, , , ), ), , ), QueryDeviceRelations : TComp(struct __anonstruct_QueryDeviceRelations_70, Type : TNamed(DEVICE_RELATION_TYPE, Enum(_DEVICE_RELATION_TYPE,), ), , ), QueryInterface : TComp(struct __anonstruct_QueryInterface_71, InterfaceType : TPtr(TNamed(GUID, TComp(struct _GUID, Data1 : TInt(unsigned long, ), Data2 : TInt(unsigned short, ), Data3 : TInt(unsigned short, ), Data4 : TArray(TInt(unsigned char, ), Some(Const(Int(8,int,8))), ), , ),  const  ), ), Size : TNamed(USHORT, TInt(unsigned short, ), ), Version : TNamed(USHORT, TInt(unsigned short, ), ), Interface : TNamed(PINTERFACE, TPtr(TComp(struct _INTERFACE, Size : TNamed(USHORT, TInt(unsigned short, ), ), Version : TNamed(USHORT, TInt(unsigned short, ), ), Context : TNamed(PVOID, TPtr(TVoid(), ), ), InterfaceReference : TPtr(TFun(TVoid(), Context: TNamed(PVOID, TPtr(TVoid(), ), ), ), ), InterfaceDereference : TPtr(TFun(TVoid(), Context: TNamed(PVOID, TPtr(TVoid(), ), ), ), ), , ), ), ), InterfaceSpecificData : TNamed(PVOID, TPtr(TVoid(), ), ), , ), DeviceCapabilities : TComp(struct __anonstruct_DeviceCapabilities_72, Capabilities : TNamed(PDEVICE_CAPABILITIES, TPtr(TComp(struct _DEVICE_CAPABILITIES, Size : TNamed(USHORT, TInt(unsigned short, ), ), Version : TNamed(USHORT, TInt(unsigned short, ), ), DeviceD1 : TNamed(ULONG, TInt(unsigned long, ), ), DeviceD2 : TNamed(ULONG, TInt(unsigned long, ), ), LockSupported : TNamed(ULONG, TInt(unsigned long, ), ), EjectSupported : TNamed(ULONG, TInt(unsigned long, ), ), Removable : TNamed(ULONG, TInt(unsigned long, ), ), DockDevice : TNamed(ULONG, TInt(unsigned long, ), ), UniqueID : TNamed(ULONG, TInt(unsigned long, ), ), SilentInstall : TNamed(ULONG, TInt(unsigned long, ), ), RawDeviceOK : TNamed(ULONG, TInt(unsigned long, ), ), SurpriseRemovalOK : TNamed(ULONG, TInt(unsigned long, ), ), WakeFromD0 : TNamed(ULONG, TInt(unsigned long, ), ), WakeFromD1 : TNamed(ULONG, TInt(unsigned long, ), ), WakeFromD2 : TNamed(ULONG, TInt(unsigned long, ), ), WakeFromD3 : TNamed(ULONG, TInt(unsigned long, ), ), HardwareDisabled : TNamed(ULONG, TInt(unsigned long, ), ), NonDynamic : TNamed(ULONG, TInt(unsigned long, ), ), WarmEjectSupported : TNamed(ULONG, TInt(unsigned long, ), ), Reserved : TNamed(ULONG, TInt(unsigned long, ), ), Address : TNamed(ULONG, TInt(unsigned long, ), ), UINumber : TNamed(ULONG, TInt(unsigned long, ), ), DeviceState : TArray(TNamed(DEVICE_POWER_STATE, Enum(_DEVICE_POWER_STATE,), ), Some(Const(Int(7,int,7))), ), SystemWake : TNamed(SYSTEM_POWER_STATE, Enum(_SYSTEM_POWER_STATE,), ), DeviceWake : TNamed(DEVICE_POWER_STATE, Enum(_DEVICE_POWER_STATE,), ), D1Latency : TNamed(ULONG, TInt(unsigned long, ), ), D2Latency : TNamed(ULONG, TInt(unsigned long, ), ), D3Latency : TNamed(ULONG, TInt(unsigned long, ), ), , ), ), ), , ), FilterResourceRequirements : TComp(struct __anonstruct_FilterResourceRequirements_73, IoResourceRequirementList : TNamed(PIO_RESOURCE_REQUIREMENTS_LIST, TPtr(TComp(struct _IO_RESOURCE_REQUIREMENTS_LIST, ListSize : TNamed(ULONG, TInt(unsigned long, ), ), InterfaceType : TNamed(INTERFACE_TYPE, Enum(_INTERFACE_TYPE,), ), BusNumber : TNamed(ULONG, TInt(unsigned long, ), ), SlotNumber : TNamed(ULONG, TInt(unsigned long, ), ), Reserved : TArray(TNamed(ULONG, TInt(unsigned long, ), ), Some(Const(Int(3,int,3))), ), AlternativeLists : TNamed(ULONG, TInt(unsigned long, ), ), List : TArray(TNamed(IO_RESOURCE_LIST, TComp(struct _IO_RESOURCE_LIST, Version : TNamed(USHORT, TInt(unsigned short, ), ), Revision : TNamed(USHORT, TInt(unsigned short, ), ), Count : TNamed(ULONG, TInt(unsigned long, ), ), Descriptors : TArray(TNamed(IO_RESOURCE_DESCRIPTOR, TComp(struct _IO_RESOURCE_DESCRIPTOR, Option : TNamed(UCHAR, TInt(unsigned char, ), ), Type : TNamed(UCHAR, TInt(unsigned char, ), ), ShareDisposition : TNamed(UCHAR, TInt(unsigned char, ), ), Spare1 : TNamed(UCHAR, TInt(unsigned char, ), ), Flags : TNamed(USHORT, TInt(unsigned short, ), ), Spare2 : TNamed(USHORT, TInt(unsigned short, ), ), u : TComp(union __anonunion_u_24, Port : TComp(struct __anonstruct_Port_25, Length : TNamed(ULONG, TInt(unsigned long, ), ), Alignment : TNamed(ULONG, TInt(unsigned long, ), ), MinimumAddress : TNamed(PHYSICAL_ADDRESS, TNamed(LARGE_INTEGER, TCompLoop(union _LARGE_INTEGER, _, ), ), ), MaximumAddress : TNamed(PHYSICAL_ADDRESS, TNamed(LARGE_INTEGER, TCompLoop(union _LARGE_INTEGER, _, ), ), ), , ), Memory : TComp(struct __anonstruct_Memory_26, Length : TNamed(ULONG, TInt(unsigned long, ), ), Alignment : TNamed(ULONG, TInt(unsigned long, ), ), MinimumAddress : TNamed(PHYSICAL_ADDRESS, TNamed(LARGE_INTEGER, TCompLoop(union _LARGE_INTEGER, _, ), ), ), MaximumAddress : TNamed(PHYSICAL_ADDRESS, TNamed(LARGE_INTEGER, TCompLoop(union _LARGE_INTEGER, _, ), ), ), , ), Interrupt : TComp(struct __anonstruct_Interrupt_27, MinimumVector : TNamed(ULONG, TInt(unsigned long, ), ), MaximumVector : TNamed(ULONG, TInt(unsigned long, ), ), , ), Dma : TComp(struct __anonstruct_Dma_28, MinimumChannel : TNamed(ULONG, TInt(unsigned long, ), ), MaximumChannel : TNamed(ULONG, TInt(unsigned long, ), ), , ), Generic : TComp(struct __anonstruct_Generic_29, Length : TNamed(ULONG, TInt(unsigned long, ), ), Alignment : TNamed(ULONG, TInt(unsigned long, ), ), MinimumAddress : TNamed(PHYSICAL_ADDRESS, TNamed(LARGE_INTEGER, TCompLoop(union _LARGE_INTEGER, _, ), ), ), MaximumAddress : TNamed(PHYSICAL_ADDRESS, TNamed(LARGE_INTEGER, TCompLoop(union _LARGE_INTEGER, _, ), ), ), , ), DevicePrivate : TComp(struct __anonstruct_DevicePrivate_30, Data : TArray(TNamed(ULONG, TInt(unsigned long, ), ), Some(Const(Int(3,int,3))), ), , ), BusNumber : TComp(struct __anonstruct_BusNumber_31, Length : TNamed(ULONG, TInt(unsigned long, ), ), MinBusNumber : TNamed(ULONG, TInt(unsigned long, ), ), MaxBusNumber : TNamed(ULONG, TInt(unsigned long, ), ), Reserved : TNamed(ULONG, TInt(unsigned long, ), ), , ), AssignedResource : TComp(struct __anonstruct_AssignedResource_32, AssignedResource : TNamed(PASSIGNED_RESOURCE, TNamed(PVOID, TPtr(TVoid(), ), ), ), , ), SubAllocateFrom : TComp(struct __anonstruct_SubAllocateFrom_33, Type : TNamed(UCHAR, TInt(unsigned char, ), ), Reserved : TArray(TNamed(UCHAR, TInt(unsigned char, ), ), Some(Const(Int(3,int,3))), ), AssignedResource : TNamed(PASSIGNED_RESOURCE, TNamed(PVOID, TPtr(TVoid(), ), ), ), Transformation : TNamed(PHYSICAL_ADDRESS, TNamed(LARGE_INTEGER, TCompLoop(union _LARGE_INTEGER, _, ), ), ), , ), ConfigData : TComp(struct __anonstruct_ConfigData_34, Priority : TNamed(ULONG, TInt(unsigned long, ), ), Reserved1 : TNamed(ULONG, TInt(unsigned long, ), ), Reserved2 : TNamed(ULONG, TInt(unsigned long, ), ), , ), , ), , ), ), Some(Const(Int(1,int,1))), ), , ), ), Some(Const(Int(1,int,1))), ), , ), ), ), , ), ReadWriteConfig : TComp(struct __anonstruct_ReadWriteConfig_74, WhichSpace : TNamed(ULONG, TInt(unsigned long, ), ), Buffer : TNamed(PVOID, TPtr(TVoid(), ), ), Offset : TNamed(ULONG, TInt(unsigned long, ), ), Length : TNamed(ULONG, TInt(unsigned long, ), ), , ), SetLock : TComp(struct __anonstruct_SetLock_75, Lock : TNamed(BOOLEAN, TNamed(UCHAR, TInt(unsigned char, ), ), ), , ), QueryId : TComp(struct __anonstruct_QueryId_76, IdType : TNamed(BUS_QUERY_ID_TYPE, Enum(__anonenum_BUS_QUERY_ID_TYPE_53,), ), , ), QueryDeviceText : TComp(struct __anonstruct_QueryDeviceText_77, DeviceTextType : TNamed(DEVICE_TEXT_TYPE, Enum(__anonenum_DEVICE_TEXT_TYPE_54,), ), LocaleId : TNamed(LCID, TNamed(ULONG, TInt(unsigned long, ), ), ), , ), UsageNotification : TComp(struct __anonstruct_UsageNotification_78, InPath : TNamed(BOOLEAN, TNamed(UCHAR, TInt(unsigned char, ), ), ), Reserved : TArray(TNamed(BOOLEAN, TNamed(UCHAR, TInt(unsigned char, ), ), ), Some(Const(Int(3,int,3))), ), Type : TNamed(DEVICE_USAGE_NOTIFICATION_TYPE, Enum(_DEVICE_USAGE_NOTIFICATION_TYPE,), ), , ), WaitWake : TComp(struct __anonstruct_WaitWake_79, PowerState : TNamed(SYSTEM_POWER_STATE, Enum(_SYSTEM_POWER_STATE,), ), , ), PowerSequence : TComp(struct __anonstruct_PowerSequence_80, PowerSequence : TNamed(PPOWER_SEQUENCE, TPtr(TComp(struct _POWER_SEQUENCE, SequenceD1 : TNamed(ULONG, TInt(unsigned long, ), ), SequenceD2 : TNamed(ULONG, TInt(unsigned long, ), ), SequenceD3 : TNamed(ULONG, TInt(unsigned long, ), ), , ), ), ), , ), Power : TComp(struct __anonstruct_Power_81, SystemContext : TNamed(ULONG, TInt(unsigned long, ), ), Type : TNamed(POWER_STATE_TYPE, Enum(_POWER_STATE_TYPE,), ), State : TNamed(POWER_STATE, TComp(union _POWER_STATE, SystemState : TNamed(SYSTEM_POWER_STATE, Enum(_SYSTEM_POWER_STATE,), ), DeviceState : TNamed(DEVICE_POWER_STATE, Enum(_DEVICE_POWER_STATE,), ), , ), ), ShutdownType : TNamed(POWER_ACTION, Enum(__anonenum_POWER_ACTION_11,), ), , ), StartDevice : TComp(struct __anonstruct_StartDevice_82, AllocatedResources : TNamed(PCM_RESOURCE_LIST, TPtr(TComp(struct _CM_RESOURCE_LIST, Count : TNamed(ULONG, TInt(unsigned long, ), ), List : TArray(TNamed(CM_FULL_RESOURCE_DESCRIPTOR, TComp(struct _CM_FULL_RESOURCE_DESCRIPTOR, InterfaceType : TNamed(INTERFACE_TYPE, Enum(_INTERFACE_TYPE,), ), BusNumber : TNamed(ULONG, TInt(unsigned long, ), ), PartialResourceList : TNamed(CM_PARTIAL_RESOURCE_LIST, TComp(struct _CM_PARTIAL_RESOURCE_LIST, Version : TNamed(USHORT, TInt(unsigned short, ), ), Revision : TNamed(USHORT, TInt(unsigned short, ), ), Count : TNamed(ULONG, TInt(unsigned long, ), ), PartialDescriptors : TArray(TNamed(CM_PARTIAL_RESOURCE_DESCRIPTOR, TComp(struct _CM_PARTIAL_RESOURCE_DESCRIPTOR, Type : TNamed(UCHAR, TInt(unsigned char, ), ), ShareDisposition : TNamed(UCHAR, TInt(unsigned char, ), ), Flags : TNamed(USHORT, TInt(unsigned short, ), ), u : TComp(union __anonunion_u_15, Generic : TComp(struct __anonstruct_Generic_16, Start : TNamed(PHYSICAL_ADDRESS, TNamed(LARGE_INTEGER, TCompLoop(union _LARGE_INTEGER, _, ), ), ), Length : TNamed(ULONG, TInt(unsigned long, ), ), , ), Port : TComp(struct __anonstruct_Port_17, Start : TNamed(PHYSICAL_ADDRESS, TNamed(LARGE_INTEGER, TCompLoop(union _LARGE_INTEGER, _, ), ), ), Length : TNamed(ULONG, TInt(unsigned long, ), ), , ), Interrupt : TComp(struct __anonstruct_Interrupt_18, Level : TNamed(ULONG, TInt(unsigned long, ), ), Vector : TNamed(ULONG, TInt(unsigned long, ), ), Affinity : TNamed(ULONG, TInt(unsigned long, ), ), , ), Memory : TComp(struct __anonstruct_Memory_19, Start : TNamed(PHYSICAL_ADDRESS, TNamed(LARGE_INTEGER, TCompLoop(union _LARGE_INTEGER, _, ), ), ), Length : TNamed(ULONG, TInt(unsigned long, ), ), , ), Dma : TComp(struct __anonstruct_Dma_20, Channel : TNamed(ULONG, TInt(unsigned long, ), ), Port : TNamed(ULONG, TInt(unsigned long, ), ), Reserved1 : TNamed(ULONG, TInt(unsigned long, ), ), , ), DevicePrivate : TComp(struct __anonstruct_DevicePrivate_21, Data : TArray(TNamed(ULONG, TInt(unsigned long, ), ), Some(Const(Int(3,int,3))), ), , ), BusNumber : TComp(struct __anonstruct_BusNumber_22, Start : TNamed(ULONG, TInt(unsigned long, ), ), Length : TNamed(ULONG, TInt(unsigned long, ), ), Reserved : TNamed(ULONG, TInt(unsigned long, ), ), , ), DeviceSpecificData : TComp(struct __anonstruct_DeviceSpecificData_23, DataSize : TNamed(ULONG, TInt(unsigned long, ), ), Reserved1 : TNamed(ULONG, TInt(unsigned long, ), ), Reserved2 : TNamed(ULONG, TInt(unsigned long, ), ), , ), , ), , ), ), Some(Const(Int(1,int,1))), ), , ), ), , ), ), Some(Const(Int(1,int,1))), ), , ), ), ), AllocatedResourcesTranslated : TNamed(PCM_RESOURCE_LIST, TPtr(TCompLoop(struct _CM_RESOURCE_LIST, _, ), ), ), , ), WMI : TComp(struct __anonstruct_WMI_83, ProviderId : TNamed(ULONG_PTR, TInt(unsigned long, ), ), DataPath : TNamed(PVOID, TPtr(TVoid(), ), ), BufferSize : TNamed(ULONG, TInt(unsigned long, ), ), Buffer : TNamed(PVOID, TPtr(TVoid(), ), ), , ), Others : TComp(struct __anonstruct_Others_84, Argument1 : TNamed(PVOID, TPtr(TVoid(), ), ), Argument2 : TNamed(PVOID, TPtr(TVoid(), ), ), Argument3 : TNamed(PVOID, TPtr(TVoid(), ), ), Argument4 : TNamed(PVOID, TPtr(TVoid(), ), ), , ), , ), DeviceObject : TNamed(PDEVICE_OBJECT, TPtr(TCompLoop(struct _DEVICE_OBJECT, _, ), ), ), FileObject : TNamed(PFILE_OBJECT, TPtr(TCompLoop(struct _FILE_OBJECT, _, ), ), ), CompletionRoutine : TPtr(TFun(TNamed(NTSTATUS, TNamed(LONG, TInt(long, ), ), ), DeviceObject: TNamed(PDEVICE_OBJECT, TPtr(TCompLoop(struct _DEVICE_OBJECT, _, ), ), ), Irp: TNamed(PIRP, TPtr(TCompLoop(struct _IRP, _, ), ), ), Context: TNamed(PVOID, TPtr(TVoid(), ), ), ), ), Context : TNamed(PVOID, TPtr(TVoid(), ), ), , ), ), ), Const(Int(0,int,0))), Field(CompletionRoutine:TPtr(TFun(TNamed(NTSTATUS, TNamed(LONG, TInt(long, ), ), ), DeviceObject: TNamed(PDEVICE_OBJECT, TPtr(TCompLoop(struct _DEVICE_OBJECT, _, ), ), ), Irp: TNamed(PIRP, TPtr(TCompLoop(struct _IRP, _, ), ), ), Context: TNamed(PVOID, TPtr(TVoid(), ), ), ), ), NoOffset))))) (/mnt/goblint-svcomp/benchexec/sv-benchmarks/c/ntdrivers/diskperf.i.cil-2.c:2378:3-2378:84)
[Info][Unsound] Unknown address in {&event} has escaped. (/mnt/goblint-svcomp/benchexec/sv-benchmarks/c/ntdrivers/diskperf.i.cil-2.c:2399:3-2399:31)
[Info][Unsound] Unknown value in {?} could be an escaped pointer address! (/mnt/goblint-svcomp/benchexec/sv-benchmarks/c/ntdrivers/diskperf.i.cil-2.c:2399:3-2399:31)
[Warning][Integer > Overflow][CWE-190][CWE-191] Unsigned integer overflow and underflow (/mnt/goblint-svcomp/benchexec/sv-benchmarks/c/ntdrivers/diskperf.i.cil-2.c:2402:3-2402:54)
[Warning][Integer > Overflow][CWE-190][CWE-191] Unsigned integer overflow and underflow (/mnt/goblint-svcomp/benchexec/sv-benchmarks/c/ntdrivers/diskperf.i.cil-2.c:2403:3-2403:53)
[Info][Unsound] Unknown address given as function argument (/mnt/goblint-svcomp/benchexec/sv-benchmarks/c/ntdrivers/diskperf.i.cil-2.c:2404:3-2404:67)
[Info][Unsound] Unknown address in {&irp} has escaped. (/mnt/goblint-svcomp/benchexec/sv-benchmarks/c/ntdrivers/diskperf.i.cil-2.c:2404:3-2404:67)
[Info][Unsound] Unknown value in {&irp} could be an escaped pointer address! (/mnt/goblint-svcomp/benchexec/sv-benchmarks/c/ntdrivers/diskperf.i.cil-2.c:2404:3-2404:67)
[Info][Unsound] Unknown value in {?} could be an escaped pointer address! (/mnt/goblint-svcomp/benchexec/sv-benchmarks/c/ntdrivers/diskperf.i.cil-2.c:2404:3-2404:67)
[Info][Unsound] Unknown address in {&event} has escaped. (/mnt/goblint-svcomp/benchexec/sv-benchmarks/c/ntdrivers/diskperf.i.cil-2.c:2404:3-2404:67)
[Info][Unsound] Unknown address given as function argument (/mnt/goblint-svcomp/benchexec/sv-benchmarks/c/ntdrivers/diskperf.i.cil-2.c:3857:7-3857:63)
[Info][Unsound] Unknown address in {&irp} has escaped. (/mnt/goblint-svcomp/benchexec/sv-benchmarks/c/ntdrivers/diskperf.i.cil-2.c:3857:7-3857:63)
[Info][Unsound] Unknown value in {&irp} could be an escaped pointer address! (/mnt/goblint-svcomp/benchexec/sv-benchmarks/c/ntdrivers/diskperf.i.cil-2.c:3857:7-3857:63)
[Info][Unsound] Unknown value in {?} could be an escaped pointer address! (/mnt/goblint-svcomp/benchexec/sv-benchmarks/c/ntdrivers/diskperf.i.cil-2.c:3857:7-3857:63)
[Info][Unsound] Unknown address in {&event} has escaped. (/mnt/goblint-svcomp/benchexec/sv-benchmarks/c/ntdrivers/diskperf.i.cil-2.c:3857:7-3857:63)
[Info][Unsound] Unknown address in {&event} has escaped. (/mnt/goblint-svcomp/benchexec/sv-benchmarks/c/ntdrivers/diskperf.i.cil-2.c:2408:5-2408:55)
[Info][Unsound] Unknown value in {?} could be an escaped pointer address! (/mnt/goblint-svcomp/benchexec/sv-benchmarks/c/ntdrivers/diskperf.i.cil-2.c:2408:5-2408:55)
[Info][Unsound] Unknown address given as function argument (/mnt/goblint-svcomp/benchexec/sv-benchmarks/c/ntdrivers/diskperf.i.cil-2.c:2288:3-2288:82)
[Info][Unsound] Unknown address in {&devobj} has escaped. (/mnt/goblint-svcomp/benchexec/sv-benchmarks/c/ntdrivers/diskperf.i.cil-2.c:2288:3-2288:82)
[Info][Unsound] Unknown value in {&devobj} could be an escaped pointer address! (/mnt/goblint-svcomp/benchexec/sv-benchmarks/c/ntdrivers/diskperf.i.cil-2.c:2288:3-2288:82)
[Info][Unsound] Unknown value in {?} could be an escaped pointer address! (/mnt/goblint-svcomp/benchexec/sv-benchmarks/c/ntdrivers/diskperf.i.cil-2.c:2288:3-2288:82)
[Warning][Behavior > Undefined > NullPointerDereference][CWE-476] May dereference NULL pointer (/mnt/goblint-svcomp/benchexec/sv-benchmarks/c/ntdrivers/diskperf.i.cil-2.c:2153:3-2153:50)
[Info][Unsound] Unknown address in {&devobj} has escaped. (/mnt/goblint-svcomp/benchexec/sv-benchmarks/c/ntdrivers/diskperf.i.cil-2.c:2289:3-2289:39)
[Info][Unsound] Unknown value in {&devobj} could be an escaped pointer address! (/mnt/goblint-svcomp/benchexec/sv-benchmarks/c/ntdrivers/diskperf.i.cil-2.c:2289:3-2289:39)
[Info][Unsound] Unknown value in {?} could be an escaped pointer address! (/mnt/goblint-svcomp/benchexec/sv-benchmarks/c/ntdrivers/diskperf.i.cil-2.c:2289:3-2289:39)
[Info][Unsound] Unknown address given as function argument (/mnt/goblint-svcomp/benchexec/sv-benchmarks/c/ntdrivers/diskperf.i.cil-2.c:2768:3-2770:50)
[Info][Unsound] Unknown value in {&ioStatus} could be an escaped pointer address! (/mnt/goblint-svcomp/benchexec/sv-benchmarks/c/ntdrivers/diskperf.i.cil-2.c:2768:3-2770:50)
[Info][Unsound] Unknown address in {&event} has escaped. (/mnt/goblint-svcomp/benchexec/sv-benchmarks/c/ntdrivers/diskperf.i.cil-2.c:2768:3-2770:50)
[Info][Unsound] Unknown value in {?} could be an escaped pointer address! (/mnt/goblint-svcomp/benchexec/sv-benchmarks/c/ntdrivers/diskperf.i.cil-2.c:2768:3-2770:50)
[Info][Unsound] Unknown address in {&devobj} has escaped. (/mnt/goblint-svcomp/benchexec/sv-benchmarks/c/ntdrivers/diskperf.i.cil-2.c:2774:5-2774:58)
[Info][Unsound] Unknown value in {&devobj} could be an escaped pointer address! (/mnt/goblint-svcomp/benchexec/sv-benchmarks/c/ntdrivers/diskperf.i.cil-2.c:2774:5-2774:58)
[Info][Unsound] Unknown value in {?} could be an escaped pointer address! (/mnt/goblint-svcomp/benchexec/sv-benchmarks/c/ntdrivers/diskperf.i.cil-2.c:2774:5-2774:58)
[Info][Unsound] Unknown address in {&devobj} has escaped. (/mnt/goblint-svcomp/benchexec/sv-benchmarks/c/ntdrivers/diskperf.i.cil-2.c:2969:3-2969:119)
[Info][Unsound] Unknown value in {&devobj} could be an escaped pointer address! (/mnt/goblint-svcomp/benchexec/sv-benchmarks/c/ntdrivers/diskperf.i.cil-2.c:2969:3-2969:119)
[Info][Unsound] Unknown value in {?} could be an escaped pointer address! (/mnt/goblint-svcomp/benchexec/sv-benchmarks/c/ntdrivers/diskperf.i.cil-2.c:2969:3-2969:119)
[Warning][Integer > Overflow][CWE-190] Unsigned integer overflow (/mnt/goblint-svcomp/benchexec/sv-benchmarks/c/ntdrivers/diskperf.i.cil-2.c:2972:7-2972:65)
[Warning][Behavior > Undefined > NullPointerDereference][CWE-476] May dereference NULL pointer (/mnt/goblint-svcomp/benchexec/sv-benchmarks/c/ntdrivers/diskperf.i.cil-2.c:2974:5-2974:41)
[Warning][Behavior > Undefined > NullPointerDereference][CWE-476] May dereference NULL pointer (/mnt/goblint-svcomp/benchexec/sv-benchmarks/c/ntdrivers/diskperf.i.cil-2.c:2975:5-2975:47)
[Warning][Behavior > Undefined > NullPointerDereference][CWE-476] May dereference NULL pointer (/mnt/goblint-svcomp/benchexec/sv-benchmarks/c/ntdrivers/diskperf.i.cil-2.c:2976:5-2976:40)
[Warning][Behavior > Undefined > NullPointerDereference][CWE-476] May dereference NULL pointer (/mnt/goblint-svcomp/benchexec/sv-benchmarks/c/ntdrivers/diskperf.i.cil-2.c:2977:5-2977:79)
[Warning][Behavior > Undefined > NullPointerDereference][CWE-476] May dereference NULL pointer (/mnt/goblint-svcomp/benchexec/sv-benchmarks/c/ntdrivers/diskperf.i.cil-2.c:2978:5-2978:57)
[Info][Unsound] Unknown address given as function argument (/mnt/goblint-svcomp/benchexec/sv-benchmarks/c/ntdrivers/diskperf.i.cil-2.c:2781:3-2781:67)
